﻿using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace ThreeWaySort
{
    public partial class Form1 : Form
    {
        public class RowClass
        {
            private string myColumn1;
            private double myColumn2; // I want Three way sorting for this column
            private double myColumn3; // I want Three way sorting for this column
            private double myColumn4;
            private int myColumn5;
            private int myColumn6;
            private int myColumn7;
            private double myColumn8;
            private double myColumn9;

            public RowClass(
                String column1,
                double column2,
                double column3,
                double column4,
                int column5,
                int column6,
                int column7,
                double column8,
                double column9)
            {
                myColumn1 = column1;
                myColumn2 = column2;
                myColumn3 = column3;
                myColumn4 = column4;
                myColumn5 = column5;
                myColumn6 = column6;
                myColumn7 = column7;
                myColumn8 = column8;
                myColumn9 = ((myColumn8 != 0)
                        ? ((myColumn5 + myColumn7) / myColumn8) : 0);
            }

            public string Column1
            {
                get
                {
                    return myColumn1;
                }

                set
                {
                    myColumn1 = value;
                }
            }

            public double Column2
            {
                get
                {
                    return myColumn2;
                }

                set
                {
                    myColumn2 = value;
                }
            }

            public double Column3
            {
                get
                {
                    return myColumn3;
                }

                set
                {
                    myColumn3 = value;
                }
            }

            public double Column4
            {
                set
                {
                    myColumn4 = value;
                }
                get
                {
                    return myColumn4;
                }
            }

            public int Column5
            {
                get
                {
                    return myColumn5;
                }

                set
                {
                    myColumn5 = value;
                }
            }

            public int Column6
            {
                get
                {
                    return myColumn6;
                }

                set
                {
                    myColumn6 = value;
                }
            }

            public int Column7
            {
                get
                {
                    return myColumn7;
                }

                set
                {
                    myColumn7 = value;
                }
            }


            public double Column8
            {
                get
                {
                    return myColumn8;
                }

                set
                {
                    myColumn8 = value;
                }
            }

            public double Column9
            {
                get
                {
                    return ((Column8 != 0)
                            ? ((Column5 + Column7) / Column8) : 0);
                }
            }

        }

        public Form1()
        {
            InitializeComponent();
            myOne = new RowClass("Column1", 1.05, 2.07, 3, 30, 50, 100, 100.0, 20.0);
            myTwo = new RowClass("Column1", 1.05, 2.07, 3, 30, 50, 100, 100.0, 20.0);
            RowClass three = new RowClass("Column1", 1.05, 2.07, 3, 30, 50, 100, 100.0, 20.0);

            RowClass four = new RowClass("Column1", 1.05, 2.07, 3, 30, 50, 100, 100.0, 20.0);

            BindingList<RowClass> bList = new BindingList<RowClass>();
            bList.Add(myOne);
            bList.Add(myTwo);
            bList.Add(three);
            bList.Add(four);
            this.ultraGrid.DataSource = bList;

            Timer timer = new Timer();
            timer.Interval = 500;
            timer.Enabled = true;
            timer.Tick += new EventHandler(onTimerEvent);
        }

        public void onTimerEvent(Object source, EventArgs e)
        {
            myValue--;

            myOne.Column1 = "Moola";
            myOne.Column2 = 60 + myValue;
            myOne.Column3 = 70 + myValue;
            myOne.Column4 = 100;
            myOne.Column5 = 300;
            myOne.Column6 = 500;
            myOne.Column7 = 700;
            myOne.Column8 = 1000;

            myTwo.Column1 = "Two";
            myTwo.Column2 = myValue;
            myTwo.Column3 = myValue;
            myTwo.Column4 = 100;
            myTwo.Column5 = 300;
            myTwo.Column6 = 500;
            myTwo.Column7 = 700;
            myTwo.Column8 = 1000;


            this.ultraGrid.Refresh();

        }

        private RowClass myOne;
        private RowClass myTwo;

        private int myValue = 0;


    }
}

